/*
 * The sample shows asynchronous call of 
 * time consuming operation
 *
 */

		private delegate void myDelegate();

		private void FillBooks()
		{
			Thread.Sleep(10000);
			oleDbConnection1.Open();
			oleDbDataAdapter2.Fill(dataSet11);
		}

		private void EndFillBooks(IAsyncResult r)
		{
			myDelegate mydel  = (myDelegate)r.AsyncState;

			mydel.EndInvoke(r);
		}
		
		private IAsyncResult BeginFillBooks()
		{
			myDelegate mydel = new myDelegate(FillBooks);
			AsyncCallback asyncCallback = new AsyncCallback(EndFillBooks);

			IAsyncResult r = mydel.BeginInvoke(asyncCallback, mydel);

			return r;
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			//FillBooks();
			BeginFillBooks();
		}